#pragma once

#include <list>


#include "W32Console.h"

#include "GameObject.h"



class CPlayer;

class AsciiApp : public CW32Console
{

  public:

    enum eGameState
    {
      GS_FLYING,
      GS_MOTHERSHIP,
      GS_TITLE,
      GS_GAMEOVER,
    };

    enum eGameOverReason
    {
      GOR_DIED,
      GOR_OUT_OF_FUEL,
    };



    typedef std::list<CGameObject*>   tListObjects;

    tListObjects    m_listObjects;

    DWORD           m_dwLastTicks;

    bool            m_bShutDown;

    int             m_iXOffset;
    int             m_iYOffset;

    bool            m_bKeyPressed[260];
    bool            m_bKeyReleased[260];

    CPlayer*        m_pPlayer;

    eGameState      m_GameState;

    eGameOverReason m_GameOverReason;




    AsciiApp();
    ~AsciiApp();

    void            Display();
    void            Update( const float fElapsedTime );

    virtual void    OnKeyEvent( const INPUT_RECORD& inputEvent );


    int             Run();


    void            ClearAllObjects();

    void            OnCollision( CGameObject* pObj1, CGameObject* pObj2 );

    void            CreateRandomAsteroid();

};
