#include ".\player.h"
#include ".\AsciiApp.h"
#include ".\Shot.h"



CPlayer::CPlayer() :
  m_iOre( 0 ),
  m_iOreMax( 10 ),
  m_iShield( 3 ),
  m_iShieldMax( 3 ),
  m_iFuel( 3500 ),
  m_iFuelMax( 3500 ),
  m_iWeaponDelay( 0 ),
  m_iCredits( 50 ),
  m_iShipLevel( 1 ),
  m_bRadar( false )
{

  m_Type = GO_PLAYER;

}

CPlayer::~CPlayer()
{
}



void CPlayer::Display( AsciiApp& App, int iXOffset, int iYOffset )
{

  switch ( m_Dir )
  {
    case DIR_N:
      App.PutChar( m_iX - iXOffset, m_iY - iYOffset - 1, 0xb3 );
      App.PutChar( m_iX - iXOffset - 1, m_iY - iYOffset, 0xda );
      App.PutChar( m_iX - iXOffset, m_iY - iYOffset, 0xc1 );
      App.PutChar( m_iX - iXOffset + 1, m_iY - iYOffset, 0xbf );
      break;
    case DIR_S:
      App.PutChar( m_iX - iXOffset - 1, m_iY - iYOffset, 0xc0 );
      App.PutChar( m_iX - iXOffset, m_iY - iYOffset, 0xc2 );
      App.PutChar( m_iX - iXOffset + 1, m_iY - iYOffset, 0xd9 );
      App.PutChar( m_iX - iXOffset, m_iY - iYOffset + 1, 0xb3 );
      break;
    case DIR_E:
      App.PutChar( m_iX - iXOffset, m_iY - iYOffset - 1, 0xbf );
      App.PutChar( m_iX - iXOffset, m_iY - iYOffset, 0xc3 );
      App.PutChar( m_iX - iXOffset + 1, m_iY - iYOffset, 0xc4 );
      App.PutChar( m_iX - iXOffset, m_iY - iYOffset + 1, 0xd9 );
      break;
    case DIR_W:
      App.PutChar( m_iX - iXOffset, m_iY - iYOffset - 1, 0xda );
      App.PutChar( m_iX - iXOffset - 1, m_iY - iYOffset, 0xc4 );
      App.PutChar( m_iX - iXOffset, m_iY - iYOffset, 0xb4 );
      App.PutChar( m_iX - iXOffset, m_iY - iYOffset + 1, 0xc0 );
      break;
  }

  if ( m_bRadar )
  {
    App.PutChar( m_iRadarX, m_iRadarY, '!', 0, AsciiApp::COL_LIGHT_TURKEY );
  }

}



void CPlayer::Update( AsciiApp& App )
{

  if ( m_iWeaponDelay > 0 )
  {
    m_iWeaponDelay--;
  }

  if ( m_iFuel )
  {
    bool    bMoved = false;

    if ( App.m_bKeyPressed[VK_LEFT] )
    {
      m_iX--;
      m_Dir = DIR_W;
      m_iFuel--;

      bMoved = true;
    }
    if ( App.m_bKeyPressed[VK_RIGHT] )
    {
      m_iX++;
      m_Dir = DIR_E;
      m_iFuel--;

      bMoved = true;
    }
    if ( App.m_bKeyPressed[VK_UP] )
    {
      m_iY--;
      m_Dir = DIR_N;
      m_iFuel--;

      bMoved = true;
    }
    if ( App.m_bKeyPressed[VK_DOWN] )
    {
      m_iY++;
      m_Dir = DIR_S;
      m_iFuel--;

      bMoved = true;
    }

    if ( ( bMoved )
    &&   ( m_bRadar ) )
    {
      // find closest Asteroid
      float   fDistanceSquared = -1.0f;

      int     iBestX = 0;
      int     iBestY = 0;

      AsciiApp::tListObjects::iterator    it( App.m_listObjects.begin() );
      while ( it != App.m_listObjects.end() )
      {
        CGameObject*    pObj( *it );

        if ( pObj->m_Type == CGameObject::GO_ASTEROID )
        {
          float   fDistance = (float)( pObj->m_iX - m_iX ) * ( pObj->m_iX - m_iX ) + (float)( pObj->m_iY - m_iY ) * ( pObj->m_iY - m_iY );

          if ( ( fDistance < fDistanceSquared )
          ||   ( fDistanceSquared < 0.0f ) )
          {
            fDistanceSquared = fDistance;

            iBestX = pObj->m_iX;
            iBestY = pObj->m_iY;
          }
        }

        ++it;
      }

      if ( iBestX < m_iX )
      {
        m_iRadarX = 0;
      }
      else if ( iBestX > m_iX )
      {
        m_iRadarX = 79;
      }
      else
      {
        m_iRadarX = 39;
      }
      if ( iBestY < m_iY )
      {
        m_iRadarY = 0;
      }
      else if ( iBestY > m_iY )
      {
        m_iRadarY = 23;
      }
      else
      {
        m_iRadarY = 12;
      }
    }
  }
  else
  {
    m_bRemoveMe = true;
  }
  if ( App.m_bKeyPressed[VK_SPACE] )
  {
    if ( m_iWeaponDelay == 0 )
    {
      m_iWeaponDelay = 5;

      CShot*    pShot = new CShot( m_iX, m_iY, AsciiApp::COL_LIGHT_MAGENTA, 1 );
      pShot->m_Dir = m_Dir;

      switch ( m_Dir )
      {
        case DIR_N:
          pShot->m_iY -= 2;
          break;
        case DIR_S:
          pShot->m_iY += 2;
          break;
        case DIR_W:
          pShot->m_iX -= 2;
          break;
        case DIR_E:
          pShot->m_iX += 2;
          break;
      }
      App.m_listObjects.push_back( pShot );
    }
  }

}



int CPlayer::Size()
{

  return 3;

}