#include ".\Shot.h"
#include ".\AsciiApp.h"



CShot::CShot( int iX, int iY, int iColor, int iValue ) :
  m_iColor( iColor ),
  m_iValue( iValue )
{
  m_iX = iX;
  m_iY = iY;
  m_Type = GO_SHOT;
  m_iLifeTime = 30;
}

CShot::~CShot(void)
{
}



void CShot::Display( AsciiApp& App, int iXOffset, int iYOffset )
{

  switch ( m_Dir )
  {
    case DIR_N:
    case DIR_S:
      App.PutChar( m_iX - iXOffset, m_iY - iYOffset, 0xba, m_iColor );
      break;
    case DIR_W:
    case DIR_E:
      App.PutChar( m_iX - iXOffset, m_iY - iYOffset, 0xcd, m_iColor );
      break;
  }

}



void CShot::Update( AsciiApp& App )
{

  if ( m_iLifeTime )
  {
    switch ( m_Dir )
    {
      case DIR_N:
        m_iY -= 2;
        break;
      case DIR_S:
        m_iY += 2;
        break;
      case DIR_W:
        m_iX -= 2;
        break;
      case DIR_E:
        m_iX += 2;
        break;
    }
    m_iLifeTime--;
  }
  else
  {
    m_bRemoveMe = true;
  }

}



int CShot::Size()
{

  return 1;

}