#ifndef W32_CONSOLE_H
#define W32_CONSOLE_H

#include <windows.h>
#include <wincon.h>

#include <string>



class CW32Console
{

  public:

    enum eColorValues
    {
      COL_BLACK         = 0,
      COL_BLUE          = FOREGROUND_BLUE,
      COL_GREEN         = FOREGROUND_GREEN,
      COL_TURKEY        = FOREGROUND_BLUE | FOREGROUND_GREEN,
      COL_RED           = FOREGROUND_RED,
      COL_MAGENTA       = FOREGROUND_RED | FOREGROUND_BLUE,
      COL_BROWN         = FOREGROUND_RED | FOREGROUND_GREEN,
      COL_LIGHT_GREY    = FOREGROUND_RED | FOREGROUND_GREEN | FOREGROUND_BLUE,

      COL_GREY          = FOREGROUND_INTENSITY,
      COL_LIGHT_BLUE    = FOREGROUND_INTENSITY | FOREGROUND_BLUE,
      COL_LIGHT_GREEN   = FOREGROUND_INTENSITY | FOREGROUND_GREEN,
      COL_LIGHT_TURKEY  = FOREGROUND_INTENSITY | FOREGROUND_BLUE | FOREGROUND_GREEN,
      COL_LIGHT_RED     = FOREGROUND_INTENSITY | FOREGROUND_RED,
      COL_LIGHT_MAGENTA = FOREGROUND_INTENSITY | FOREGROUND_RED | FOREGROUND_BLUE,
      COL_YELLOW        = FOREGROUND_INTENSITY | FOREGROUND_RED | FOREGROUND_GREEN,
      COL_WHITE         = FOREGROUND_INTENSITY | FOREGROUND_RED | FOREGROUND_GREEN | FOREGROUND_BLUE,
    };


	  CW32Console();
	  virtual ~CW32Console();


    void            PutChar( int iX, int iY, unsigned char cChar, unsigned char ucFGColor = COL_GREY, unsigned char ucBGColor = COL_BLACK );
    void            WriteString( int iX, int iY, const std::string& strText, unsigned char ucFGColor = COL_GREY, unsigned char ucBGColor = COL_BLACK );

	  void            SetCursorVisible( bool visible );

    void            ShowBufferedScreen();

    void            ProcessInput();

    virtual void    OnKeyEvent( const INPUT_RECORD& inputEvent );
    virtual void    OnMouseEvent( const INPUT_RECORD& inputEvent );


  protected:

    CHAR_INFO       m_ScreenBuffer[25 * 80];

	  HANDLE          m_StdOut;
	  HANDLE          m_StdIn;

    HANDLE          m_hScreen;

};



#endif // W32_CONSOLE_H